/*
 * blanco Framework
 * Copyright (C) 2004-2006 IGA Tosiki
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 */
package blanco.batchprocess;

import java.io.File;
import java.util.List;

import blanco.batchprocess.stringgroup.BlancoBatchProcessSupportedLangStringGroup;
import blanco.batchprocess.valueobject.BlancoBatchProcessInputItemStructure;
import blanco.batchprocess.valueobject.BlancoBatchProcessStructure;
import blanco.cg.BlancoCgObjectFactory;
import blanco.cg.transformer.BlancoCgTransformerFactory;
import blanco.cg.valueobject.BlancoCgClass;
import blanco.cg.valueobject.BlancoCgField;
import blanco.cg.valueobject.BlancoCgMethod;
import blanco.cg.valueobject.BlancoCgSourceFile;
import blanco.commons.util.BlancoJavaSourceUtil;
import blanco.commons.util.BlancoNameAdjuster;
import blanco.commons.util.BlancoStringUtil;

/**
 * ob`ۃNXWJ܂B
 */
class BlancoBatchProcessExpandBatchProcess {
    /**
     * o͑ΏۂƂȂvO~OB
     */
    private int fTargetLang = BlancoBatchProcessSupportedLangStringGroup.NOT_DEFINED;

    /**
     * ^CpbP[WB
     */
    private String fRuntimePackage = null;

    /**
     * IɗpblancoCgpt@NgB
     */
    private BlancoCgObjectFactory fCgFactory = null;

    /**
     * IɗpblancoCgp\[Xt@CB
     */
    private BlancoCgSourceFile fCgSourceFile = null;

    /**
     * IɗpblancoCgpNXB
     */
    private BlancoCgClass fCgClass = null;

    /**
     * WꂽɁA\[XR[h܂B
     * 
     * @param argProcessStructure
     *            ^t@CWł\f[^B
     * @param argRuntimePackage
     *            ^CpbP[WBnullђ0̏̕ꍇ͒`ƂɃ^CNX𐶐B
     * @param argTargetLang
     *            o͑ΏۃvO~OB
     * @param argDirectoryTarget
     *            \[XR[h̏o͐tH_B
     */
    public void expandSourceFile(
            final BlancoBatchProcessStructure argProcessStructure,
            final String argRuntimePackage, final int argTargetLang,
            final File argDirectoryTarget) {
        fRuntimePackage = argRuntimePackage;
        fTargetLang = argTargetLang;

        // ]ƌ݊邽߁A/mainTutH_ɏo͂܂B
        final File fileBlancoMain = new File(argDirectoryTarget
                .getAbsolutePath()
                + "/main");

        fCgFactory = BlancoCgObjectFactory.getInstance();
        fCgSourceFile = fCgFactory.createSourceFile(argProcessStructure
                .getPackage(), "̃\[XR[h blanco FrameworkɂĎĂ܂B");
        fCgClass = fCgFactory.createClass("Abstract"
                + BlancoNameAdjuster.toClassName(argProcessStructure.getName())
                + BlancoStringUtil.null2Blank(argProcessStructure.getSuffix()),
                BlancoStringUtil.null2Blank(argProcessStructure
                        .getDescription()));
        fCgSourceFile.getClassList().add(fCgClass);

        fCgClass.setAbstract(true);
        fCgClass.setAccess("");

        fCgClass.setDescription("ob`NX ["
                + BlancoNameAdjuster.toClassName(argProcessStructure.getName())
                + BlancoStringUtil.null2Blank(argProcessStructure.getSuffix())
                + "]̒ېeNXB");
        fCgClass.getLangDoc().getDescriptionList().add(
                "̃NXp ["
                        + argProcessStructure.getPackage()
                        + "]pbP[W["
                        + BlancoNameAdjuster.toClassName(argProcessStructure
                                .getName())
                        + BlancoStringUtil.null2Blank(argProcessStructure
                                .getSuffix()) + "]NX쐬Ďۂ̃ob`ĂB");

        expandField(argProcessStructure);
        expandMethodMain(argProcessStructure);
        expandMethodProcess(argProcessStructure);
        expandMethodExecute(argProcessStructure);
        expandMethodUsage(argProcessStructure);

        new BlancoBatchProcessExpandValueObject().expandSourceFile(
                argRuntimePackage, argProcessStructure, argDirectoryTarget);

        if (BlancoStringUtil.null2Blank(
                argProcessStructure.getOutput().getEndBatchProcessException())
                .length() > 0) {
            // ob`OI̒lݒ肳Ăꍇɂ̂ݐ܂B

            fCgSourceFile
                    .getImportList()
                    .add(
                            getBlancoBatchProcessExceptionClassName(argProcessStructure));

            if (BlancoStringUtil.null2Blank(fRuntimePackage).length() == 0) {
                // `ƂɓpbP[WɃ^CNX𐶐B
                new BlancoBatchProcessExpandException().expandSourceFile(
                        argProcessStructure.getPackage(), fTargetLang,
                        argDirectoryTarget);
            } else {
                // ^CpbP[Ww肪̂ŁAw̃^CpbP[WɃNX𐶐B
                new BlancoBatchProcessExpandException().expandSourceFile(
                        fRuntimePackage, fTargetLang, argDirectoryTarget);
            }
        }

        switch (fTargetLang) {
        case BlancoBatchProcessSupportedLangStringGroup.JAVA:
            BlancoCgTransformerFactory.getJavaSourceTransformer().transform(
                    fCgSourceFile, fileBlancoMain);
            break;
        default:
            break;
        }
    }

    /**
     * tB[hWJ܂B
     * 
     * @param argProcessStructure
     *            ^t@CWł\f[^B
     */
    private void expandField(
            final BlancoBatchProcessStructure argProcessStructure) {

        {
            final BlancoCgField field = fCgFactory.createField("END_SUCCESS",
                    "int", "IB");
            fCgClass.getFieldList().add(field);

            field.setAccess("public");
            field.setStatic(true);
            field.setFinal(true);
            field.setDefault(argProcessStructure.getOutput().getEndSuccess());
        }

        if (BlancoStringUtil.null2Blank(
                argProcessStructure.getOutput().getEndBatchProcessException())
                .length() > 0) {
            // ob`OI̒lݒ肳Ăꍇɂ̂ݐ܂B

            final BlancoCgField field = fCgFactory.createField(
                    "END_BATCHPROCESS_EXCEPTION", "int",
                    "ob`OIBIBatchProcessExceptionꍇB");
            fCgClass.getFieldList().add(field);

            field.setAccess("public");
            field.setStatic(true);
            field.setFinal(true);
            field.setDefault(argProcessStructure.getOutput()
                    .getEndBatchProcessException());
        }

        {
            final BlancoCgField field = fCgFactory.createField(
                    "END_ILLEGAL_ARGUMENT", "int",
                    "ُ͈IBIjava.lang.IllegalArgumentExceptionꍇB");
            fCgClass.getFieldList().add(field);

            field.setAccess("public");
            field.setStatic(true);
            field.setFinal(true);
            field.setDefault(argProcessStructure.getOutput()
                    .getEndIllegalArgument());
        }

        {
            final BlancoCgField field = fCgFactory
                    .createField(
                            "END_ERROR",
                            "int",
                            "ُIBob`̏JnɎsꍇAѓIjava.lang.Error܂java.lang.RuntimeExceptionꍇB");
            fCgClass.getFieldList().add(field);

            field.setAccess("public");
            field.setStatic(true);
            field.setFinal(true);
            field.setDefault(argProcessStructure.getOutput().getEndError());
        }
    }

    /**
     * main \bhWJ܂B
     * 
     * @param argProcessStructure
     *            ^t@CWł\f[^B
     */
    private void expandMethodMain(
            final BlancoBatchProcessStructure argProcessStructure) {

        final BlancoCgMethod method = fCgFactory.createMethod("main",
                "R}hCsꂽۂ̃Gg|CgłB");
        fCgClass.getMethodList().add(method);

        method.setStatic(true);
        method.setFinal(true);
        method.getParameterList().add(
                fCgFactory.createParameter("args", "java.lang.String[]",
                        "R\[pꂽB"));

        final List listLine = method.getLineList();
        listLine.add("// ̉ӏŃRpCG[ꍇAAbstract"
                + BlancoNameAdjuster.toClassName(argProcessStructure.getName())
                + BlancoStringUtil.null2Blank(argProcessStructure.getSuffix())
                + "NXp " + argProcessStructure.getPackage() + "pbP[W "
                + BlancoNameAdjuster.toClassName(argProcessStructure.getName())
                + BlancoStringUtil.null2Blank(argProcessStructure.getSuffix())
                + "NX쐬邱Ƃɂłꍇ܂B");
        listLine.add("final Abstract"
                + BlancoNameAdjuster.toClassName(argProcessStructure.getName())
                + BlancoStringUtil.null2Blank(argProcessStructure.getSuffix())
                + " batchProcess = new "
                + BlancoNameAdjuster.toClassName(argProcessStructure.getName())
                + BlancoStringUtil.null2Blank(argProcessStructure.getSuffix())
                + "();");
        listLine.add("");
        listLine.add("// ob`̈B");
        final String valueObjectClassname = BlancoBatchProcessExpandValueObject
                .getClassName(argProcessStructure);
        fCgSourceFile.getImportList().add(
                argProcessStructure.getPackage() + ".valueobject."
                        + valueObjectClassname);
        listLine.add("final " + valueObjectClassname + " input = new "
                + valueObjectClassname + "();");
        listLine.add("");
        listLine.add("boolean isNeedUsage = false;");
        listLine.add("");
        listLine.add("// R}hC̉͂Ȃ܂B");
        listLine.add("for (int index = 0; index < args.length; index++) {");
        listLine.add("String arg = args[index];");
        for (int index = 0; index < argProcessStructure.getInputItemList()
                .size(); index++) {
            final BlancoBatchProcessInputItemStructure inputItem = (BlancoBatchProcessInputItemStructure) argProcessStructure
                    .getInputItemList().get(index);
            String line = "";
            if (index == 0) {
            } else {
                line += "} else ";
            }
            line += "if (arg.startsWith(\"-" + inputItem.getName() + "=\")) {";
            listLine.add(line);
            listLine.add("input.set"
                    + BlancoNameAdjuster.toClassName(inputItem.getName())
                    + "(arg.substring(" + (inputItem.getName().length() + 2)
                    + "));");
        }
        listLine.add((argProcessStructure.getInputItemList().size() == 0 ? ""
                : "} else ")
                + "if (arg.equals(\"-?\") || arg.equals(\"-help\")) {");
        listLine.add("usage();");
        listLine.add("System.exit(END_SUCCESS);");
        listLine.add("} else {");
        listLine.add("System.out.println(\""
                + BlancoNameAdjuster.toClassName(argProcessStructure.getName())
                + BlancoStringUtil.null2Blank(argProcessStructure.getSuffix())
                + ": ̓p[^[\" + arg + \"]͖܂B\");");
        listLine.add("isNeedUsage = true;");
        listLine.add("}");
        listLine.add("}");
        listLine.add("");
        listLine.add("if (isNeedUsage) {");
        listLine.add("usage();");
        listLine.add("}");
        listLine.add("");
        listLine.add("int retCode = batchProcess.execute(input);");
        listLine.add("");
        listLine.add("// IR[h߂܂B");
        listLine.add("// ӁFSystem.exit()ĂяoĂ_ɒӂĂB");
        listLine.add("System.exit(retCode);");
    }

    /**
     * execute \bhWJ܂B
     * 
     * @param argProcessStructure
     *            ^t@CWł\f[^B
     */
    private void expandMethodExecute(
            final BlancoBatchProcessStructure argProcessStructure) {

        final BlancoCgMethod method = fCgFactory.createMethod("execute",
                "NXCX^Xăob`sۂ̃Gg|CgłB");
        fCgClass.getMethodList().add(method);

        method.setFinal(true);
        method.getParameterList().add(
                fCgFactory.createParameter("input", argProcessStructure
                        .getPackage()
                        + ".valueobject."
                        + BlancoBatchProcessExpandValueObject
                                .getClassName(argProcessStructure),
                        "ob`̓̓p[^B"));
        method.setReturn(fCgFactory.createReturn("int", "ob`̏IR[hB"
                + BlancoStringUtil.null2Blank(argProcessStructure.getOutput()
                        .getDescription())));

        final List listLine = method.getLineList();

        listLine.add("try {");
        if (argProcessStructure.getShowMessageBeginEnd()) {
            listLine.add("System.out.println(\""
                    + BlancoNameAdjuster.toClassName(argProcessStructure
                            .getName())
                    + BlancoStringUtil.null2Blank(argProcessStructure
                            .getSuffix()) + ": begin\");");
            listLine.add("");
        }

        for (int index = 0; index < argProcessStructure.getInputItemList()
                .size(); index++) {
            final BlancoBatchProcessInputItemStructure inputItem = (BlancoBatchProcessInputItemStructure) argProcessStructure
                    .getInputItemList().get(index);
            if (inputItem.getRequire()) {
                listLine.add("if (input.get"
                        + BlancoNameAdjuster.toClassName(inputItem.getName())
                        + "() == null) {");
                listLine.add("System.out.println(\""
                        + BlancoNameAdjuster.toClassName(argProcessStructure
                                .getName())
                        + BlancoStringUtil.null2Blank(argProcessStructure
                                .getSuffix()) + ": JnsBK{̓̓p[^["
                        + inputItem.getName() + "]ݒ肳Ă܂B\");");
                listLine.add("System.exit(END_ILLEGAL_ARGUMENT);");
                listLine.add("}");
                listLine.add("");
            }
        }

        listLine.add("// ob`̖{̂s܂B");
        listLine.add("int retCode = process(input);");
        listLine.add("");
        if (argProcessStructure.getShowMessageBeginEnd()) {
            listLine.add("System.out.println(\""
                    + BlancoNameAdjuster.toClassName(argProcessStructure
                            .getName())
                    + BlancoStringUtil.null2Blank(argProcessStructure
                            .getSuffix()) + ": end (\" + retCode + \")\");");
        }
        listLine.add("return retCode;");

        if (BlancoStringUtil.null2Blank(
                argProcessStructure.getOutput().getEndBatchProcessException())
                .length() > 0) {
            // ob`OI̒lݒ肳Ăꍇɂ̂ݐ܂B

            listLine.add("} catch (BlancoBatchProcessException ex) {");
            listLine.add("System.out.println(\""
                    + BlancoNameAdjuster.toClassName(argProcessStructure
                            .getName())
                    + BlancoStringUtil.null2Blank(argProcessStructure
                            .getSuffix())
                    + ": ob`O܂Bob`𒆒f܂B:\" + ex.toString());");
            listLine.add("// ob`OIB");
            listLine.add("return END_BATCHPROCESS_EXCEPTION;");
        }
        listLine.add("} catch (IllegalArgumentException ex) {");
        listLine.add("System.out.println(\""
                + BlancoNameAdjuster.toClassName(argProcessStructure.getName())
                + BlancoStringUtil.null2Blank(argProcessStructure.getSuffix())
                + ": ͗O܂Bob`𒆒f܂B:\" + ex.toString());");
        listLine.add("// ُ͈IB");
        listLine.add("return END_ILLEGAL_ARGUMENT;");
        listLine.add("} catch (RuntimeException ex) {");
        listLine.add("System.out.println(\""
                + BlancoNameAdjuster.toClassName(argProcessStructure.getName())
                + BlancoStringUtil.null2Blank(argProcessStructure.getSuffix())
                + ": ^CO܂Bob`𒆒f܂B:\" + ex.toString());");
        listLine.add("ex.printStackTrace();");
        listLine.add("// ُIB");
        listLine.add("return END_ERROR;");
        listLine.add("} catch (Error er) {");
        listLine.add("System.out.println(\""
                + BlancoNameAdjuster.toClassName(argProcessStructure.getName())
                + BlancoStringUtil.null2Blank(argProcessStructure.getSuffix())
                + ": ^CG[܂Bob`𒆒f܂B:\" + er.toString());");
        listLine.add("er.printStackTrace();");
        listLine.add("// ُIB");
        listLine.add("return END_ERROR;");
        listLine.add("}");
    }

    /**
     * process \bhWJ܂B
     * 
     * @param argProcessStructure
     *            ^t@CWł\f[^B
     */
    private void expandMethodProcess(
            final BlancoBatchProcessStructure argProcessStructure) {

        final BlancoCgMethod method = fCgFactory.createMethod("process",
                "̓Iȃob`eLq邽߂̃\bhłB");
        fCgClass.getMethodList().add(method);

        method.getLangDoc().getDescriptionList().add("̃\bhɎۂ̏eLq܂B");
        method.getParameterList().add(
                fCgFactory.createParameter("input", argProcessStructure
                        .getPackage()
                        + ".valueobject."
                        + BlancoBatchProcessExpandValueObject
                                .getClassName(argProcessStructure),
                        "ob`̓̓p[^B"));
        method.setAbstract(true);
        method.setReturn(fCgFactory.createReturn("int", "ob`̏IR[hB"
                + BlancoStringUtil.null2Blank(argProcessStructure.getOutput()
                        .getDescription())));
    }

    /**
     * execute \bhWJ܂B
     * 
     * @param argProcessStructure
     *            ^t@CWł\f[^B
     */
    private void expandMethodUsage(
            final BlancoBatchProcessStructure argProcessStructure) {

        final BlancoCgMethod method = fCgFactory.createMethod("usage",
                "̃ob`NX̎g̐Wo͂Ɏ߂̃\bhłB");
        fCgClass.getMethodList().add(method);

        method.setStatic(true);
        method.setFinal(true);

        final List listLine = method.getLineList();
        listLine.add("System.out.println(\""
                + BlancoNameAdjuster.toClassName(argProcessStructure.getName())
                + BlancoStringUtil.null2Blank(argProcessStructure.getSuffix())
                + ": Usage:\");");
        {
            String strArg = "System.out.println(\"  java "
                    + argProcessStructure.getPackage()
                    + "."
                    + BlancoNameAdjuster.toClassName(argProcessStructure
                            .getName())
                    + BlancoStringUtil.null2Blank(argProcessStructure
                            .getSuffix());
            for (int index = 0; index < argProcessStructure.getInputItemList()
                    .size(); index++) {
                final BlancoBatchProcessInputItemStructure inparam = (BlancoBatchProcessInputItemStructure) argProcessStructure
                        .getInputItemList().get(index);
                strArg += " -" + inparam.getName() + "=l" + (index + 1) + "";
            }
            strArg += "\");";
            listLine.add(strArg);
        }

        for (int index = 0; index < argProcessStructure.getInputItemList()
                .size(); index++) {
            final BlancoBatchProcessInputItemStructure inputItem = (BlancoBatchProcessInputItemStructure) argProcessStructure
                    .getInputItemList().get(index);
            listLine.add("System.out.println(\"    -" + inputItem.getName()
                    + "\");");
            if (inputItem.getDescription() != null) {
                listLine.add("System.out.println(\"      ["
                        + BlancoJavaSourceUtil
                                .escapeStringAsJavaSource(inputItem
                                        .getDescription()) + "]\");");
            }
            if (inputItem.getRequire()) {
                listLine.add("System.out.println(\"      K{p[^B\");");
            }
            if (inputItem.getDefault() != null) {
                listLine.add("System.out.println(\"      ftHgl["
                        + BlancoJavaSourceUtil
                                .escapeStringAsJavaSource(inputItem
                                        .getDefault()) + "]\");");
            }
        }
        listLine.add("System.out.println(\"    -? , -help\");");
        listLine.add("System.out.println(\"      [g\܂B]\");");
    }

    private String getBlancoBatchProcessExceptionClassName(
            final BlancoBatchProcessStructure argProcessStructure) {
        if (BlancoStringUtil.null2Blank(
                argProcessStructure.getOutput().getEndBatchProcessException())
                .length() == 0) {
            throw new IllegalArgumentException(
                    "ob`OIOFFł̂ɁABlancoBatchProcessException NX擾̃\bhĂяo܂BĂ܂");
        }

        if (BlancoStringUtil.null2Blank(fRuntimePackage).length() == 0) {
            return argProcessStructure.getPackage()
                    + ".BlancoBatchProcessException";
        } else {
            return fRuntimePackage + ".BlancoBatchProcessException";
        }
    }
}
