/*
 * blanco Framework
 * Copyright (C) 2004-2007 IGA Tosiki
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 */
package blanco.encryption;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.util.zip.GZIPInputStream;
import java.util.zip.GZIPOutputStream;

import javax.crypto.Cipher;
import javax.crypto.CipherInputStream;
import javax.crypto.CipherOutputStream;
import javax.crypto.NoSuchPaddingException;

import blanco.commons.util.BlancoStreamUtil;

/**
 * gvDES (Triple DES) ASYɂt@CÍc[B
 * 
 * t@C̊gqɂAÍ^̔fȂ悤ɂȂĂ܂B
 * 
 * @author IGA Tosiki
 */
public class BlancoEncryptionDesede {
    /**
     * pASYB
     */
    private static final String ALGORITHM = "DESede";

    /**
     * ÍȂ܂B
     * 
     * Iɂ GZIPks܂B
     * 
     * @param argFileInput
     *            ̓t@CB
     * @param argFileOutput
     *            o̓t@C(Í)B
     * @param argPassword
     *            ÍpX[hB
     * @throws IOException
     *             o͗O ꍇB
     */
    public void encrypt(final File argFileInput, final File argFileOutput,
            final String argPassword) throws IOException {
        // TODO ̓p[^`FbN̎B
        // TODO t@C݃`FbNB

        try {
            final InputStream inStream = new BufferedInputStream(
                    new FileInputStream(argFileInput));

            final Cipher cipher = Cipher.getInstance(ALGORITHM);
            cipher.init(Cipher.ENCRYPT_MODE, BlancoEncryptionSecretKeyUtil
                    .getSha256KeyForDesede(argPassword));

            final OutputStream outStream = new GZIPOutputStream(
                    new CipherOutputStream(new BufferedOutputStream(
                            new FileOutputStream(argFileOutput)), cipher));

            BlancoStreamUtil.copy(inStream, outStream);

            outStream.flush();
            outStream.close();
            // TODO mclose̎B

            inStream.close();

            // ŌɃt@C̓tRs[܂B
            if (argFileOutput.setLastModified(argFileInput.lastModified()) == false) {
                throw new IllegalArgumentException("t@C̍ŏIXṼRs[Ɏs܂B");
            }
        } catch (NoSuchAlgorithmException e) {
            e.printStackTrace();
            throw new IllegalArgumentException("ASY̎擾Ɏs܂B:"
                    + e.toString());
        } catch (NoSuchPaddingException e) {
            e.printStackTrace();
            throw new IllegalArgumentException("pfBOsŎs܂B:"
                    + e.toString());
        } catch (InvalidKeyException e) {
            e.printStackTrace();
            throw new IllegalArgumentException("閧sŎs܂B:" + e.toString());
        }
    }

    /**
     * s܂B
     * 
     * Iɂ GZIPLs܂B
     * 
     * @param argFileInput
     *            ̓t@C(Í)B
     * @param argFileOutput
     *            o̓t@CB
     * @param argPassword
     *            ÍpX[hB
     * @throws IOException
     *             o͗O ꍇB
     */
    public void decrypt(final File argFileInput, final File argFileOutput,
            final String argPassword) throws IOException {
        // TODO ̓p[^`FbN̎B
        // TODO t@C݃`FbNB

        try {
            final Cipher cipher = Cipher.getInstance(ALGORITHM);
            cipher.init(Cipher.DECRYPT_MODE, BlancoEncryptionSecretKeyUtil
                    .getSha256KeyForDesede(argPassword));
            final InputStream inStream = new GZIPInputStream(
                    new CipherInputStream(new BufferedInputStream(
                            new FileInputStream(argFileInput)), cipher));

            final OutputStream outStream = new BufferedOutputStream(
                    new FileOutputStream(argFileOutput));

            BlancoStreamUtil.copy(inStream, outStream);

            inStream.close();

            outStream.flush();
            outStream.close();
            // TODO mclose̎B

        } catch (NoSuchAlgorithmException e) {
            e.printStackTrace();
            throw new IllegalArgumentException("ASY̎擾Ɏs܂B:"
                    + e.toString());
        } catch (NoSuchPaddingException e) {
            e.printStackTrace();
            throw new IllegalArgumentException("pfBOsŎs܂B:"
                    + e.toString());
        } catch (InvalidKeyException e) {
            e.printStackTrace();
            throw new IllegalArgumentException("閧sŎs܂B:" + e.toString());
        } catch (IOException e) {
            throw new IllegalArgumentException(
                    "o͗O܂BpX[hԈႢ̉\܂:" + e.toString());
        }
    }
}
